      .586
      .MMX
      .model flat, stdcall
      option casemap :none     

      include \masm32\include\windows.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\masm32.inc
      include \masm32\include\advapi32.inc


      include \masm32\macros\macros.asm
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\advapi32.lib      

      include RNG.ASM

      WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
      WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
      TopXY PROTO :DWORD,:DWORD      

.data
      hWnd           dd 0
      hInstance      dd 0
      szClassName    db "rg_class",0
      szWindowName   db "Rand Test",0
      selection      dd 0
      clear          dd 0

      buffer         db 30 dup(0)
.code

start:
      call init_crt_rand
      .if eax == 0      
         MsgBox hWnd,"init_crt_rand failed",NULL,MB_OK
      .endif
      
      ; Give csp_rand an opportunity to fail cleanly.
      invoke csp_rand,100

      invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
      invoke ExitProcess,eax

;       

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             cmdLine   :DWORD,
             cmdShow   :DWORD
      LOCAL wc    :WNDCLASSEX
      LOCAL msg   :MSG
      LOCAL wwd   :DWORD
      LOCAL wht   :DWORD
      LOCAL wtx   :DWORD
      LOCAL wty   :DWORD
      LOCAL hDC   :DWORD
      LOCAL rect  :RECT

      mov   wc.cbSize,sizeof WNDCLASSEX
      mov   wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
      mov   wc.lpfnWndProc,offset WndProc
      mov   wc.cbClsExtra,NULL
      mov   wc.cbWndExtra,NULL
      mov   eax,hInst
      mov   wc.hInstance,eax
      invoke GetStockObject,WHITE_BRUSH
      mov   wc.hbrBackground,eax
      mov   wc.lpszMenuName,NULL
      mov   wc.lpszClassName,offset szClassName
      invoke LoadIcon,NULL,IDI_APPLICATION
      mov   wc.hIcon,eax
      invoke LoadCursor,NULL,IDC_ARROW
      mov   wc.hCursor,eax
      mov   wc.hIconSm,0

      invoke RegisterClassEx,ADDR wc

      mov   wwd,600
      mov   wht,400
      invoke GetSystemMetrics,SM_CXSCREEN
      invoke TopXY,wwd,eax
      mov wtx, eax
      invoke GetSystemMetrics,SM_CYSCREEN
      invoke TopXY,wht,eax
      mov   wty,eax

      invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW,
                              ADDR szClassName,
                              ADDR szWindowName,
                              WS_OVERLAPPEDWINDOW,
                              wtx,wty,wwd,wht,
                              NULL,NULL,
                              hInst,NULL
      mov   hWnd,eax

      invoke LoadMenu,hInst,600
      invoke SetMenu,hWnd,eax

      invoke ShowWindow,hWnd,SW_SHOWNORMAL
      invoke UpdateWindow,hWnd

      invoke GetDC,hWnd
      mov   hDC,eax

   StartLoop:
      invoke PeekMessage,ADDR msg,NULL,0,0,PM_REMOVE
      cmp   eax,0
      je    @F
      cmp   msg.message,WM_QUIT
      je    ExitLoop
      invoke TranslateMessage,ADDR msg
      invoke DispatchMessage, ADDR msg
   @@:
      ;######################################################

      invoke GetClientRect,hWnd,ADDR rect

      .if clear != 0
         invoke FillRect,hDC,ADDR rect,wc.hbrBackground
         mov   clear,0
         
         .if selection == 1000
            invoke SetWindowText,hWnd,SADD("Rand Test : lfsr64_rand")
         .elseif selection == 1001
            invoke SetWindowText,hWnd,SADD("Rand Test : lfsr64_rand_vshift")
         .elseif selection == 1002
            invoke SetWindowText,hWnd,SADD("Rand Test : pdixon_lfsr64_rand")
         .elseif selection == 1003
            invoke SetWindowText,hWnd,SADD("Rand Test : pdixon_lfsr63_rand")
         .elseif selection == 1004
            invoke SetWindowText,hWnd,SADD("Rand Test : pdixon_combined")
         .elseif selection == 1005
            invoke SetWindowText,hWnd,SADD("Rand Test : lc_rand")
         .elseif selection == 1006
            invoke SetWindowText,hWnd,SADD("Rand Test : crt_rand")
         .elseif selection == 1007
            invoke SetWindowText,hWnd,SADD("Rand Test : csp_rand")
         .elseif selection == 1008
            invoke SetWindowText,hWnd,SADD("Rand Test : nrandom")
         .endif
      .endif

      .if selection == 1000
         invoke lfsr64_rand,rect.right
         mov   ebx,eax
         invoke lfsr64_rand,rect.bottom
      .elseif selection == 1001
         invoke lfsr64_rand_vshift,rect.right
         mov   ebx,eax        
         invoke lfsr64_rand_vshift,rect.bottom
      .elseif selection == 1002
         invoke pdixon_lfsr64_rand,rect.right
         mov   ebx,eax        
         invoke pdixon_lfsr64_rand,rect.bottom
      .elseif selection == 1003
         invoke pdixon_lfsr63_rand,rect.right      
         mov   ebx,eax
         invoke pdixon_lfsr63_rand,rect.bottom
      .elseif selection == 1004
         invoke pdixon_lfsr64_rand,rect.right
         mov   ebx,eax
         invoke pdixon_lfsr63_rand,rect.bottom
      .elseif selection == 1005
         invoke lc_rand,rect.right
         mov   ebx,eax
         invoke lc_rand,rect.bottom
      .elseif selection == 1006
         invoke crt_rand,rect.right
         mov   ebx,eax
         invoke crt_rand,rect.bottom
      .elseif selection == 1007
         invoke csp_rand,rect.right
         mov   ebx,eax
         invoke csp_rand,rect.bottom
      .elseif selection == 1008
         invoke nrandom,rect.right
         mov   ebx,eax
         invoke nrandom,rect.bottom
      .endif

      invoke SetPixel,hDC,ebx,eax,0

      ;######################################################

      jmp   StartLoop
    ExitLoop:
      invoke ReleaseDC,hWnd,hDC
      mov   eax,msg.wParam
      ret
WinMain endp

; 

WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

      .if uMsg == WM_COMMAND
         mov   eax,wParam
         mov   selection,eax
         mov   clear,eax
      .elseif uMsg == WM_DESTROY
         invoke PostQuitMessage,NULL
         xor   eax,eax
         ret
      .endif

      invoke DefWindowProc,hWin,uMsg,wParam,lParam
      ret
WndProc endp

; 
; This proc was used to visually confirm that the problem
; generators were producing the full range of values.
; 
IsolateX proc uses edi             
      call GetTickCount
      mov   edi,eax
   @@:
      call GetTickCount
      cmp   eax,edi
      je    @B
      mov   eax,200
      ret         
IsolateX endp

TopXY proc wDim:DWORD,sDim:DWORD
      shr   sDim,1
      shr   wDim,1
      mov   eax,wDim
      sub   sDim,eax
      mov   eax,sDim
      ret
TopXY endp

end start
